﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=6.01
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Private fx As JFX
	Private mSQL As SQL
	Private mKVS As KeyValueStore2
	Private DBVersion As Double = 0.1
	
	Public Const TABLE_PROJECTS As String = "Projects"
	Public Const TABLE_MODULES As String = "Modules"
	Public Const TABLE_FILES As String = "Files"
	Public Const TABLE_LIBRARIES As String = "Libraries"
	Public Const TABLE_ADDLJARS As String = "AddlJars"
	Public Const TABLE_VMARGS As String = "VMArgs"
	Public Const TABLE_SUBS As String = "Subs"
	Public Const TABLE_JAVACLASSES As String = "JavaClasses"
	Public Const TABLE_JAVAEVENTS As String = "JavaEvents"
	Public Const TABLE_TYPES As String = "Types"
	Public Const TABLE_FORMS As String = "Forms"
	Public Const TABLE_PERMISSIONS As String = "Permissions"
	Public Const TABLE_VERSION As String = "Version"
	
	Public AllDataTables() As String
	
	
	Type ProjectType( _
	ProjectName As String, _
	Folder As String, _
	ProjectFileName As String, _
	LibraryName As String, _
	LibraryVersion As String, _
	Files As List, _
	Modules As List, _
	Libraries As List,  _
	Permissions As List, _
	AddlJars As List, _
	VirtualMachineArgs As List, _
	Git As Boolean, _
	LastModified As Long)
	
	Type ModuleType( _
	ModuleName As String, _
	Description As String, _
	Folder As String, _
	FileName As String, _
	ProjectFileName As String, _
	ModuleType As String, _
	CodeLines As Int, _
	CommentLines As Int, _
	FileSize As Int, _
	LastModified As Long, _
	Subs As List, _
	Types As List, _
	JavaClasses As List, _
	JavaEvents As List, _
	Forms As List)
	
End Sub


'Extracts from ChordManager.DataManager

Public Sub Initialize
	'Testing
'	File.Delete(File.DirData("projectoverview"),"data.db")
	
	AllDataTables = Array As String( _
	TABLE_PROJECTS, _
	TABLE_MODULES, _
	TABLE_FILES, _
	TABLE_LIBRARIES, _
	TABLE_ADDLJARS, _
	TABLE_VMARGS, _
	TABLE_SUBS, _
	TABLE_JAVACLASSES, _
	TABLE_JAVAEVENTS, _
	TABLE_TYPES, _
	TABLE_PERMISSIONS, _
	TABLE_FORMS)
	mKVS.Initialize(File.DirData("projectoverview"),"useropts.db")
	mSQL.InitializeSQLite(File.DirData("projectoverview"),"data.db",True)
	If CheckSQLTable(TABLE_PROJECTS) = 0 Then
		CreateTables(DBVersion)
	End If
	CheckVersion
	
	
End Sub

'Return the current SQLite Database
Public Sub SQL As SQL
	Return mSQL
End Sub

Public Sub KVS As KeyValueStore2
	Return mKVS
End Sub

Private Sub CreateTables(Version As Double) As Boolean
	Log("CreateTables")
	Dim Query As String


	mSQL.BeginTransaction
	Try
		'Project Table
		Query = $"
CREATE TABLE ${TABLE_PROJECTS} (
"ProjectName" TEXT Not Null DEFAULT '',
"Folder" TEXT Not Null DEFAULT '',
"ProjectFileName" TEXT Not Null DEFAULT '',
"LibraryName" TEXT Not Null DEFAULT '',
"LibraryVersion" TEXT Not Null DEFAULT '',
"Git" INTEGER Not Null Default 0,
"LastModified" INTEGER Not Null DEFAULT 0
)"$
		mSQL.ExecNonQuery(Query)
		
		
		'Files Table
		
		Query = $"
CREATE TABLE ${TABLE_FILES} (
"ProjectFileName" TEXT Not Null DEFAULT '',
"Folder" TEXT Not Null DEFAULT '',
"File" TEXT Not Null DEFAULT ''
)"$
		mSQL.ExecNonQuery(Query)
		
		'Libraries Table
		
		Query = $"
CREATE TABLE ${TABLE_LIBRARIES} (
"ProjectFileName" TEXT Not Null DEFAULT '',
"Folder" TEXT Not Null DEFAULT '',
"Library" TEXT Not Null DEFAULT ''
)"$
		mSQL.ExecNonQuery(Query)
		
		
		'AddlJars Table

		Query = $"
CREATE TABLE ${TABLE_ADDLJARS} (
"ProjectFileName" TEXT Not Null DEFAULT '',
"Folder" TEXT Not Null DEFAULT '',
"AddlJar" TEXT Not Null DEFAULT ''
)"$
		mSQL.ExecNonQuery(Query)
		
		'VNArgs TAble
		
		Query = $"
CREATE TABLE ${TABLE_VMARGS} (
"ProjectFileName" TEXT Not Null DEFAULT '',
"Folder" TEXT Not Null DEFAULT '',
"VMArg" TEXT Not Null DEFAULT ''
)"$
		mSQL.ExecNonQuery(Query)
		
		'Android Permissions
		Query = $"
CREATE TABLE ${TABLE_PERMISSIONS} (
"ProjectFileName" TEXT Not Null DEFAULT '',
"Folder" TEXT Not Null DEFAULT '',
"Permission" TEXT Not Null DEFAULT ''
)"$
		mSQL.ExecNonQuery(Query)
		
		'Module Table
		
		Query = $"
CREATE TABLE ${TABLE_MODULES} (
"ModuleName" TEXT Not Null DEFAULT '',
"Folder" TEXT Not Null DEFAULT '',
"FileName" TEXT Not Null DEFAULT '',
"ProjectFileName" TEXT Not Null DEFAULT '',
"Description" Text Not Null DEFAULT '',
"Type" TEXT Not Null DEFAULT '',
"CodeLines" INTEGER Not Null DEFAULT 0,
"CommentLines" INTEGER Not Null DEFAULT 0,
"FileSize" INTEGER Not Null DEFAULT 0,
"LastModified" INTEGER Not Null DEFAULT 0
"ProjectFolder" TEXT Not Null DEFAULT '',
)"$

		mSQL.ExecNonQuery(Query)
		
		'Subs Table
		
		Query = $"
CREATE TABLE ${TABLE_SUBS} (
"FileName" TEXT Not Null DEFAULT '',
"Folder" TEXT Not Null DEFAULT '',
"ProjectFileName" TEXT Not Null DEFAULT '',
"Sub" TEXT Not Null DEFAULT '',
"Params" TEXT Not Null DEFAULT ''
)"$
		mSQL.ExecNonQuery(Query)
		
		'Types Table
		Query = $"
CREATE TABLE ${TABLE_TYPES} (
"FileName" TEXT Not Null DEFAULT '',
"Folder" TEXT Not Null DEFAULT '',
"ProjectFileName" TEXT Not Null DEFAULT '',
"Type" TEXT Not Null DEFAULT '', 
"Params" TEXT Not Null DEFAULT ''
)"$
		mSQL.ExecNonQuery(Query)
		
		'JavaClasses Table
		Query = $"
CREATE TABLE ${TABLE_JAVACLASSES} (
"FileName" TEXT Not Null DEFAULT '',
"Folder" TEXT Not Null DEFAULT '',
"ProjectFileName" TEXT Not Null DEFAULT '',
"JavaClass" TEXT Not Null DEFAULT ''
)"$
		mSQL.ExecNonQuery(Query)
		
		'JavaEvents Table
		Query = $"
CREATE TABLE ${TABLE_JAVAEVENTS} (
"FileName" TEXT Not Null DEFAULT '',
"Folder" TEXT Not Null DEFAULT '',
"ProjectFileName" TEXT Not Null DEFAULT '',
"JavaEvent" TEXT Not Null DEFAULT ''
)"$
		mSQL.ExecNonQuery(Query)
		
		'Forms Table
		Query = $"
CREATE TABLE ${TABLE_FORMS} (
"FileName" TEXT Not Null DEFAULT '',
"Folder" TEXT Not Null DEFAULT '',
"ProjectFileName" TEXT Not Null DEFAULT '',
"Form" TEXT Not Null DEFAULT ''
)"$
		mSQL.ExecNonQuery(Query)
		
		'Version Table
		Query = $"
CREATE TABLE ${TABLE_VERSION} (
"Version" TEXT
)"$
		mSQL.ExecNonQuery(Query)
		
		Query = $"
INSERT INTO Version VALUES(?)
"$
		mSQL.ExecNonQuery2(Query,Array As String(Version))
		
		
	
		'(KEY COLLATE NOCASE) creates case insensitive indexes as we are using LIKE to search which is case insensitive.
		For Each Table As String In AllDataTables
			Query = $"
CREATE INDEX idx_${Table}_ProjectFileName ON ${Table} (ProjectFileName)"$
			SQL.ExecNonQuery(Query)
			
			Query = $"
CREATE INDEX idx_${Table}_Folder ON ${Table} (Folder)"$
			SQL.ExecNonQuery(Query)
		Next


	Catch
		Log(LastException)
		Return False
	End Try
	mSQL.TransactionSuccessful
	Return True
	
End Sub

Private Sub CheckSQLTable(Name As String) As Int
	Dim Count As Int
	Try
		Count = mSQL.ExecQuerySingleResult($"SELECT COUNT(name) FROM sqlite_master WHERE type='table' AND name= '${Name}'"$)
	Catch
		Log(LastException)
		Return -1
	End Try
	Return Count
End Sub

Public Sub CheckVersion
	Try
		mSQL.ExecQuerySingleResult($"SELECT ProjectFolder From ${TABLE_MODULES}"$)
	Catch
		Log("Updating DataBase")
		mSQL.ExecNonQuery($"ALTER TABLE ${TABLE_MODULES} ADD COLUMN ProjectFolder TEXT Not Null DEFAULT ''"$)
	End Try
	
	Try
		mSQL.ExecQuerySingleResult($"SELECT ProjectFolder From ${TABLE_MODULES}"$)
	Catch
		fx.Msgbox(Null,"Could not update database","Update failed")
		ExitApplication
	End Try
	
	Try
		mSQL.ExecQuerySingleResult($"SELECT Folder From ${TABLE_FORMS}"$)
	Catch
		Log("Updating DataBase")
		'Forms Table
		Dim Query As String = $"
CREATE TABLE ${TABLE_FORMS} (
"FileName" TEXT Not Null DEFAULT '',
"Folder" TEXT Not Null DEFAULT '',
"ProjectFileName" TEXT Not Null DEFAULT '',
"Form" TEXT Not Null DEFAULT ''
)"$
		mSQL.ExecNonQuery(Query)
	End Try
	
	Try
		mSQL.ExecQuerySingleResult($"SELECT Folder From ${TABLE_FORMS}"$)
		Log("Update Successful")
	Catch
		fx.Msgbox(Null,"Could not update database","Update failed")
		ExitApplication
	End Try
End Sub
