﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=6.01
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Private fx As JFX
End Sub

Public Sub GetProjects(GitOnly As Boolean) As List
	Dim Query As String = $"SELECT DISTINCT
	${DBAccess.TABLE_PROJECTS}.ProjectName, 
	${DBAccess.TABLE_PROJECTS}.ProjectFileName, 
	${DBAccess.TABLE_PROJECTS}.Folder, 
	${DBAccess.TABLE_PROJECTS}.LastModified, 
	SUM (DISTINCT CodeLines) AS CodeLines,
	SUM (DISTINCT CommentLines) AS CommentLines,
	${DBAccess.TABLE_PROJECTS}.LibraryName ,
	${DBAccess.TABLE_PROJECTS}.LibraryVersion ,
	SUM (DISTINCT FileSize) AS FileSize
	FROM ${DBAccess.TABLE_MODULES}"$
	
	Dim Selection As String = ""
	Dim GroupBy As String = $" GROUP BY ${DBAccess.TABLE_MODULES}.ProjectFolder, ${DBAccess.TABLE_MODULES}.ProjectFileName "$
	Dim OrderBy As String = $" ORDER BY ${DBAccess.TABLE_MODULES}.ProjectFileName COLLATE NOCASE ASC "$
	
	Dim Joins As String = $"
	JOIN ${DBAccess.TABLE_PROJECTS} ON ${DBAccess.TABLE_PROJECTS}.ProjectFileName = ${DBAccess.TABLE_MODULES}.ProjectFileName
	And ${DBAccess.TABLE_PROJECTS}.Folder = ${DBAccess.TABLE_MODULES}.ProjectFolder "$

	Dim ArgsList As List
	ArgsList.Initialize
	
	'Filters for entered text
	If Main.tfAddlJars.Text <> "" Then
		Dim AddlJarsSelection As String
		AddlJarsSelection = $" 
		${DBAccess.TABLE_PROJECTS}.ProjectFileName IN (SELECT ProjectFileName FROM ${DBAccess.TABLE_ADDLJARS} 
		WHERE Folder = ${DBAccess.TABLE_PROJECTS}.Folder AND AddlJar LIKE ?) "$
		ArgsList.Add($"${Main.tfAddlJars.Text}"$)
		Selection = AddToSelection(Selection, AddlJarsSelection)
	End If
	
	If Main.tfLibraries.Text <> "" Then
		Dim LibSelection As String = $" 
		${DBAccess.TABLE_PROJECTS}.ProjectFileName IN (SELECT ProjectFileName FROM ${DBAccess.TABLE_LIBRARIES} 
		WHERE Folder = ${DBAccess.TABLE_PROJECTS}.Folder AND Library LIKE ?) "$
		Selection = AddToSelection(Selection, LibSelection)
		ArgsList.Add($"${Main.tfLibraries.Text}"$)
	End If
	
	If Main.tfPermissions.Text <> "" Then
		Dim PermSelection As String = $"
		${DBAccess.TABLE_PROJECTS}.ProjectFileName IN (SELECT ProjectFileName FROM ${DBAccess.TABLE_PERMISSIONS} 
		WHERE Folder = ${DBAccess.TABLE_PROJECTS}.Folder AND Permission LIKE ?) "$
		Selection = AddToSelection(Selection, PermSelection)
		ArgsList.Add($"${Main.tfPermissions.Text}"$)
	End If
	
	If Main.tfVMArgs.Text <> "" Then
		Dim VMSelection As String = $"
		${DBAccess.TABLE_PROJECTS}.ProjectFileName IN (SELECT ProjectFileName FROM ${DBAccess.TABLE_VMARGS} 
		WHERE Folder = ${DBAccess.TABLE_PROJECTS}.Folder AND VMArg LIKE ?) "$
		Selection = AddToSelection(Selection, VMSelection)
		ArgsList.Add($"${Main.tfVMArgs.Text}"$)
	End If

	If Main.tfFiles.Text <> "" Then
		Dim FileSelection As String = $"
		${DBAccess.TABLE_PROJECTS}.ProjectFileName IN (SELECT ProjectFileName FROM ${DBAccess.TABLE_FILES} 
		WHERE Folder = ${DBAccess.TABLE_PROJECTS}.Folder AND File LIKE ?) "$
		Selection = AddToSelection(Selection, FileSelection)
		ArgsList.Add($"${Main.tfFiles.Text}"$)
	End If
	
	If Main.tfDescription.Text <> "" Then
		Dim DescSelection As String = $"
		${DBAccess.TABLE_MODULES}.Description Like ? "$
		Selection = AddToSelection(Selection, DescSelection)
		ArgsList.Add($"${Main.tfDescription.Text}"$)
	End If

	If Main.tfSubs.Text <> "" Then
		Dim SubSelection As String = $"
		${DBAccess.TABLE_PROJECTS}.ProjectFileName IN (SELECT ProjectFileName FROM ${DBAccess.TABLE_SUBS} 
		WHERE Folder = ${DBAccess.TABLE_PROJECTS}.Folder AND Sub LIKE ?) "$
		Selection = AddToSelection(Selection, SubSelection)
		ArgsList.Add($"${Main.tfSubs.Text}"$)
	End If
	
	If Main.tfTypes.Text <> "" Then
		Dim TypeSelection As String = $"
		${DBAccess.TABLE_PROJECTS}.ProjectFileName IN (SELECT ProjectFileName FROM ${DBAccess.TABLE_TYPES} 
		WHERE Folder = ${DBAccess.TABLE_PROJECTS}.Folder AND Type LIKE ?) "$
		Selection = AddToSelection(Selection, TypeSelection)
		ArgsList.Add($"${Main.tfTypes.Text}"$)
	End If
	
	If Main.tfJavaClasses.Text <> "" Then
		Dim JCSelection As String = $"
		${DBAccess.TABLE_PROJECTS}.ProjectFileName IN (SELECT ProjectFileName FROM ${DBAccess.TABLE_JAVACLASSES} 
		WHERE Folder = ${DBAccess.TABLE_PROJECTS}.Folder AND JavaClass LIKE ?) "$
		Selection = AddToSelection(Selection, JCSelection)
		ArgsList.Add($"${Main.tfJavaClasses.Text}"$)
	End If

	If Main.tfJavaEvents.Text <> "" Then
		Dim JCSelection As String = $"
		${DBAccess.TABLE_PROJECTS}.ProjectFileName IN (SELECT ProjectFileName FROM ${DBAccess.TABLE_JAVAEVENTS} 
		WHERE Folder = ${DBAccess.TABLE_PROJECTS}.Folder AND JavaEvent LIKE ?) "$
		Selection = AddToSelection(Selection, JCSelection)
		ArgsList.Add($"${Main.tfJavaEvents.Text}"$)
	End If
	
	If Main.tfForms.Text <> "" Then
		Dim JCSelection As String = $"
		${DBAccess.TABLE_PROJECTS}.ProjectFileName IN (SELECT ProjectFileName FROM ${DBAccess.TABLE_FORMS} 
		WHERE Folder = ${DBAccess.TABLE_PROJECTS}.Folder AND Form LIKE ?) "$
		Selection = AddToSelection(Selection, JCSelection)
		ArgsList.Add($"${Main.tfForms.Text}"$)
	End If
	
	Dim DateSelection As String
	If Main.dpStartDate.DateTicks > 0 And Main.dpEndDate.DateTicks > 0 Then
		DateSelection = $" ${DBAccess.TABLE_PROJECTS}.LastModified >= ? AND ${DBAccess.TABLE_PROJECTS}.LastModified <= ?"$
		ArgsList.Add($"${Main.dpStartDate.DateTicks}"$)
		ArgsList.Add($"${Main.dpEndDate.DateTicks + DateTime.TicksPerDay}"$)
	Else If Main.dpStartDate.DateTicks > 0 Then
		DateSelection = $" ${DBAccess.TABLE_PROJECTS}.LastModified >= ?"$
		ArgsList.Add($"${Main.dpStartDate.DateTicks}"$)
	Else If Main.dpEndDate.DateTicks > 0 Then
		DateSelection = $" ${DBAccess.TABLE_PROJECTS}.LastModified <= ?"$
		ArgsList.Add($"${Main.dpEndDate.DateTicks + DateTime.TicksPerDay}"$)
	End If
	Selection = AddToSelection(Selection, DateSelection)
	
	
	'Do these last as any previous selects are likely to retun fewer results, thus speeding the search
	If Main.tfProjectName.Text <> "" Then
		Dim ProjSelection As String
		ProjSelection = $" ProjectName LIKE ?"$
		ArgsList.Add($"${Main.tfProjectName.Text}"$)
		Selection = AddToSelection(Selection, ProjSelection)
	End If
	
	If Main.tfFolder.Text <> "" Then
		Dim FoldSelection As String
		FoldSelection = $" ${DBAccess.TABLE_PROJECTS}.Folder LIKE ?"$
		ArgsList.Add($"${Main.tfFolder.Text}"$)
		Selection = AddToSelection(Selection, FoldSelection)
	End If
	
	If Main.tfLibraryName.Text <> "" Then
		Dim LibSelection As String
		LibSelection = $" LibraryName LIKE ?"$
		ArgsList.Add($"${Main.tfLibraryName.Text}"$)
		Selection = AddToSelection(Selection, LibSelection)
	End If
	
	If Main.cbType.Value <> "All" Then
		Dim ProjSelection As String
		ProjSelection = $" ${DBAccess.TABLE_PROJECTS}.ProjectFileName LIKE ?"$
		ArgsList.Add($"%.${Main.cbType.Value}"$)
		Selection = AddToSelection(Selection, ProjSelection)
	End If
	
	If Main.tfModules.Text <> "" Then
		Dim ModuleSelection As String
		ModuleSelection = $" ${DBAccess.TABLE_MODULES}.ModuleName LIKE ?"$
		ArgsList.Add($"${Main.tfModules.Text}"$)
		Selection = AddToSelection(Selection, ModuleSelection)
	End If
	
	If Main.cbHasGit.Checked Or GitOnly Then
		Dim GitSelection As String
		GitSelection = $" ${DBAccess.TABLE_PROJECTS}.Git = ?"$
		ArgsList.Add(1)
		Selection = AddToSelection(Selection, GitSelection)
	End If

	'Convert the constructed args list to a string array we can pass to the DBUtils query	
	Dim Args(ArgsList.Size) As String
	For i = 0 To ArgsList.Size - 1
		Args(i) = ArgsList.Get(i)
	Next
	
	Query = Query & Joins & Selection & GroupBy & OrderBy
	Log(Query)
	Return DBUtils.ExecuteMemoryTable(DBAccess.SQL,Query,Args,0)
End Sub

'Add selections to the selection string using WHERE or AND As appropriate
Private Sub AddToSelection(Selection As String, New As String) As String
	If New <> "" Then
		If Selection = "" Then
			Selection = " WHERE " & New
		Else
			Selection = Selection & " AND " & New
		End If
	End If
	
	Return Selection
End Sub

'Get all available Modules for the selected projects.
Public Sub GetModules(Project() As String) As List
	Dim Query As String = $"SELECT DISTINCT
	${DBAccess.TABLE_MODULES}.ModuleName, 
	${DBAccess.TABLE_MODULES}.FileSize, 
	${DBAccess.TABLE_MODULES}.LastModified, 
	${DBAccess.TABLE_MODULES}.CodeLines, 
	${DBAccess.TABLE_MODULES}.CommentLines, 
	${DBAccess.TABLE_MODULES}.Folder,  
	${DBAccess.TABLE_MODULES}.FileName, 
	${DBAccess.TABLE_MODULES}.Description 
	FROM ${DBAccess.TABLE_MODULES} "$
	
	Dim Selection As String = $" WHERE ${DBAccess.TABLE_MODULES}.ProjectFileName = ? AND ${DBAccess.TABLE_MODULES}.ProjectFolder = ? "$
	
	Dim ArgsList As List
	ArgsList.Initialize
	ArgsList.AddAll(Array(Project(Main.PROJECT_PROJECTFILENAME),Project(Main.PROJECT_FOLDER)))
	
	'Filter modules if needed
	If Main.tfModules.Text <> "" Then
		Dim ModuleSelection As String
		ModuleSelection = $" ${DBAccess.TABLE_MODULES}.ModuleName Like ?"$
		ArgsList.Add($"${Main.tfModules.Text}"$)
		Selection = AddToSelection(Selection, ModuleSelection)
	End If
	
	If Main.tfDescription.Text <> "" Then
		Dim DescSelection As String = $"
		${DBAccess.TABLE_MODULES}.Description Like ? "$
		Selection = AddToSelection(Selection, DescSelection)
		ArgsList.Add($"${Main.tfDescription.Text}"$)
	End If
	
	Dim Args(ArgsList.Size) As String
	For i = 0 To ArgsList.Size - 1
		Args(i) = ArgsList.Get(i)
	Next
	
	Query = Query & Selection
	Return DBUtils.ExecuteMemoryTable(DBAccess.SQL,Query,Args,0)
	
End Sub

Public Sub CountFromModule(Module() As String,TableName As String, FieldName As String) As Int
	Dim Query As String = $"SELECT COUNT(DISTINCT ${TableName}.${FieldName}) FROM ${TableName}"$
	
	Dim Selection As String = $" WHERE ${TableName}.FileName = ? AND ${TableName}.Folder = ? "$
	
	Dim ArgsList As List
	ArgsList.Initialize
	ArgsList.AddAll(Array(Module(Main.MODULES_FILENAME),Module(Main.MODULES_FOLDER)))
	
	Dim Args(ArgsList.Size) As String
	For i = 0 To ArgsList.Size - 1
		Args(i) = ArgsList.Get(i)
	Next
	
	Query = Query & Selection
'	Return DBUtils.ExecuteMemoryTable(DBAccess.SQL,Query,Args,0)
	Dim L As List
	L.Initialize
	DBUtils.ExecuteList(DBAccess.SQL,Query,Args,1,L)
	Return L.Get(0)
	
End Sub

'Get all available subs 
Public Sub GetSubs(Module() As String) As List
	Dim Query As String = $"SELECT Sub, Params From ${DBAccess.TABLE_SUBS} "$
	Dim Selection As String = $" WHERE FileName = ? AND Folder = ?"$
	Dim ArgsList As List
	ArgsList.Initialize
	ArgsList.AddAll(Array(Module(Main.MODULES_FILENAME),Module(Main.MODULES_FOLDER)))
	
	'Filter if needed
	If Main.tfSubs.Text <> "" Then
		Selection = Selection & " AND Sub LIKE ? "
		ArgsList.Add($"${Main.tfSubs.Text}"$)
	End If
	
	Dim Args(ArgsList.Size) As String
	For i = 0 To ArgsList.Size - 1
		Args(i) = ArgsList.Get(i)
	Next
	
	Query = Query & Selection
	
	Return DBUtils.ExecuteMemoryTable(DBAccess.SQL,Query,Args,0)
End Sub

Public Sub GetTypes(Module() As String) As List
	Dim Query As String = $"SELECT Type, Params From ${DBAccess.TABLE_TYPES} "$
	Dim Selection As String = $" WHERE FileName = ? AND Folder = ?"$
	
	Dim ArgsList As List
	ArgsList.Initialize
	ArgsList.AddAll(Array(Module(Main.MODULES_FILENAME),Module(Main.MODULES_FOLDER)))
	
	If Main.tfTypes.Text <> "" Then
		Dim TypeSelection As String = $" Type LIKE ? "$
		Selection = AddToSelection(Selection, TypeSelection)
		ArgsList.Add($"${Main.tfTypes.Text}"$)
	End If
	
	Dim Args(ArgsList.Size) As String
	For i = 0 To ArgsList.Size - 1
		Args(i) = ArgsList.Get(i)
	Next
	
	Query = Query & Selection
	
	Return DBUtils.ExecuteMemoryTable(DBAccess.SQL,Query,Args,0)
End Sub

Public Sub GetJavaClasses(Module() As String) As List
	Dim Query As String = $"SELECT JavaClass From ${DBAccess.TABLE_JAVACLASSES} "$
	Dim Selection As String = $" WHERE FileName = ? AND Folder = ?"$
	Dim ArgsList As List
	ArgsList.Initialize
	ArgsList.AddAll(Array(Module(Main.MODULES_FILENAME),Module(Main.MODULES_FOLDER)))
	
	If Main.tfJavaClasses.Text <> "" Then
		Selection = Selection & " AND JavaClass LIKE ? "
		ArgsList.Add($"${Main.tfJavaClasses.Text}"$)
	End If
	
	Dim Args(ArgsList.Size) As String
	For i = 0 To ArgsList.Size - 1
		Args(i) = ArgsList.Get(i)
	Next
	
	Query = Query & Selection
	
	Return DBUtils.ExecuteMemoryTable(DBAccess.SQL,Query,Args,0)
End Sub

Public Sub GetItemsForProject(Project() As String, TableName As String,FieldName As String,SearchFor As String) As List
	Dim Query As String = $"SELECT FileName,${FieldName} From ${TableName} "$
	Dim Selection As String = $" WHERE ProjectFileName = ? AND Folder = ?"$
	Dim ArgsList As List
	ArgsList.Initialize
	ArgsList.AddAll(Array(Project(Main.PROJECT_PROJECTFILENAME),Project(Main.PROJECT_FOLDER)))
	
	If SearchFor <> "" Then
		Selection = Selection & $" AND ${FieldName} LIKE ? "$
		ArgsList.Add(SearchFor)
	End If
	
	Dim Args(ArgsList.Size) As String
	For i = 0 To ArgsList.Size - 1
		Args(i) = ArgsList.Get(i)
	Next
	
	Query = Query & Selection
	'
	Return DBUtils.ExecuteMemoryTable(DBAccess.SQL,Query,Args,0)
End Sub

Public Sub CountFromProject(Project() As String,TableName As String, FieldName As String) As Int
	Dim Query As String = $"SELECT COUNT(DISTINCT ${TableName}.${FieldName}) FROM ${TableName}"$
	
	Dim Selection As String = $" WHERE ${TableName}.ProjectFileName = ? AND ${TableName}.Folder = ? "$
	
	Dim ArgsList As List
	ArgsList.Initialize
	ArgsList.AddAll(Array(Project(Main.PROJECT_PROJECTFILENAME),Project(Main.PROJECT_FOLDER)))
	
	Dim Args(ArgsList.Size) As String
	For i = 0 To ArgsList.Size - 1
		Args(i) = ArgsList.Get(i)
	Next
	
	Query = Query & Selection
'	Return DBUtils.ExecuteMemoryTable(DBAccess.SQL,Query,Args,0)
	Dim L As List
	L.Initialize
	DBUtils.ExecuteList(DBAccess.SQL,Query,Args,1,L)
	Return L.Get(0)
	
End Sub

Public Sub GetItemsFromProject(Project() As String, TableName As String,FieldName As String,SearchFor As String) As List
	Dim Query As String = $"SELECT ProjectFileName,${FieldName} From ${TableName} "$
	Dim Selection As String = $" WHERE ProjectFileName = ? AND Folder = ?"$
	Dim ArgsList As List
	ArgsList.Initialize
	ArgsList.AddAll(Array(Project(Main.PROJECT_PROJECTFILENAME),Project(Main.PROJECT_FOLDER)))
	
	If SearchFor <> "" Then
		Selection = Selection & $" AND ${FieldName} LIKE ? "$
		ArgsList.Add(SearchFor)
	End If
	
	Dim Args(ArgsList.Size) As String
	For i = 0 To ArgsList.Size - 1
		Args(i) = ArgsList.Get(i)
	Next
	
	Query = Query & Selection
	'
	Return DBUtils.ExecuteMemoryTable(DBAccess.SQL,Query,Args,0)
End Sub

Public Sub GetJavaEvents(Module() As String) As List
	Dim Query As String = $"SELECT JavaEvent From ${DBAccess.TABLE_JAVAEVENTS} "$
	Dim Selection As String = $" WHERE FileName = ? AND Folder = ?"$
	Dim ArgsList As List
	ArgsList.Initialize
	ArgsList.AddAll(Array(Module(Main.MODULES_FILENAME),Module(Main.MODULES_FOLDER)))
	
	If Main.tfJavaEvents.Text <> "" Then
		Selection = Selection & " AND JavaEvent LIKE ? "
		ArgsList.Add($"${Main.tfJavaEvents.Text}"$)
	End If
	
	Dim Args(ArgsList.Size) As String
	For i = 0 To ArgsList.Size - 1
		Args(i) = ArgsList.Get(i)
	Next
	
	Query = Query & Selection
	
	Return DBUtils.ExecuteMemoryTable(DBAccess.SQL,Query,Args,0)
End Sub

Public Sub GetForms(Module() As String) As List
	Dim Query As String = $"SELECT Form From ${DBAccess.TABLE_FORMS} "$
	Dim Selection As String = $" WHERE FileName = ? AND Folder = ?"$
	Dim ArgsList As List
	ArgsList.Initialize
	ArgsList.AddAll(Array(Module(Main.MODULES_FILENAME),Module(Main.MODULES_FOLDER)))
	
	If Main.tfForms.Text <> "" Then
		Selection = Selection & " AND Form LIKE ? "
		ArgsList.Add($"${Main.tfForms.Text}"$)
	End If
	
	Dim Args(ArgsList.Size) As String
	For i = 0 To ArgsList.Size - 1
		Args(i) = ArgsList.Get(i)
	Next
	
	Query = Query & Selection
	
	Return DBUtils.ExecuteMemoryTable(DBAccess.SQL,Query,Args,0)
End Sub

Public Sub GetRecordCount(Table As String) As Int
	Dim Query As String = $"SELECT COUNT (rowid) FROM ${Table}"$
	Return DBAccess.SQL.ExecQuerySingleResult(Query)
End Sub

Public Sub GetFolders(Parent As String) As List
	Dim Query As String = $"SELECT DISTINCT rtrim(Folder, replace(Folder, '\', '')) As Parent From ${DBAccess.TABLE_PROJECTS} "$
	Dim Selection As String = $" WHERE Folder Like ?"$
	Dim OrderBy As String = $" ORDER BY Parent"$
	Dim ArgsList As List
	ArgsList.Initialize
	ArgsList.AddAll(Array($"${Parent}%"$))
	
	
	Dim Args(ArgsList.Size) As String
	For i = 0 To ArgsList.Size - 1
		Args(i) = ArgsList.Get(i)
	Next
	
	Query = Query & Selection & OrderBy
	Log("Q " & Query)
	
	Return DBUtils.ExecuteMemoryTable(DBAccess.SQL,Query,Args,0)
	
End Sub