﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=6.01
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Private fx As JFX
End Sub

Public Sub UpdateProject(Project As ProjectType)
'	Dim Query As String = $"SELECT Count(*) FROM ${DBAccess.TABLE_PROJECTS} WHERE Folder = ? AND ProjectFileName = ?"$
	Dim Query As String = $"SELECT LastModified FROM ${DBAccess.TABLE_PROJECTS} WHERE Folder = ? AND ProjectFileName = ?"$
	
	'Check if Project Exists
	 Dim LM As Object = DBAccess.SQL.ExecQuerySingleResult2( Query,Array As String(Project.Folder,Project.ProjectFileName)) 
'	 Log(LM)
	If LM <> Null Then
		If Project.LastModified = LM Then Return
		DeleteProject(Project.Folder,Project.ProjectFileName)
	End If
	
	DBAccess.SQL.BeginTransaction
	Try
		Query = $"INSERT INTO ${DBAccess.TABLE_PROJECTS} VALUES (?,?,?,?,?,?,?)"$
		DBAccess.SQL.ExecNonQuery2(Query,Array(Project.ProjectName,Project.Folder,Project.ProjectFileName,Project.LibraryName,Project.LibraryVersion,BoolAsInt(Project.Git),Project.LastModified))
		
		For Each S As String In Project.Files
			Query = $"INSERT INTO ${DBAccess.TABLE_FILES} VALUES (?,?,?)"$
			DBAccess.SQL.ExecNonQuery2(Query,Array(Project.ProjectFileName,Project.Folder,S))
		Next
		
		For Each S As String In Project.Libraries
			Query = $"INSERT INTO ${DBAccess.TABLE_LIBRARIES} VALUES (?,?,?)"$
			DBAccess.SQL.ExecNonQuery2(Query,Array(Project.ProjectFileName,Project.Folder,S))
		Next

		For Each S As String In Project.AddlJars
			Query = $"INSERT INTO ${DBAccess.TABLE_ADDLJARS} VALUES (?,?,?)"$
			DBAccess.SQL.ExecNonQuery2(Query,Array(Project.ProjectFileName,Project.Folder,S))
		Next

		For Each S As String In Project.VirtualMachineArgs
			Query = $"INSERT INTO ${DBAccess.TABLE_VMARGS} VALUES (?,?,?)"$
			DBAccess.SQL.ExecNonQuery2(Query,Array(Project.ProjectFileName,Project.Folder,S))
		Next
		
		For Each S As String In Project.Permissions
			Query = $"INSERT INTO ${DBAccess.TABLE_PERMISSIONS} VALUES (?,?,?)"$
			DBAccess.SQL.ExecNonQuery2(Query,Array(Project.ProjectFileName,Project.Folder,S))
		Next

		For Each Module As ModuleType In Project.Modules
			If Module.ModuleName = "" Then Continue
'			Log(Module.Folder & ", " & Module.FileName)
'			Query = $"Select LastModified From ${DBAccess.TABLE_MODULES} WHERE Folder = ? AND FileName = ?"$
'			Dim LM As Object = DBAccess.SQL.ExecQuerySingleResult2( Query,Array As String(Module.Folder,Module.FileName))
'			Log(LM & " : " & Module.LastModified)
'			If LM <> Null And LM = Module.LastModified Then
'				Log("Not Modified")
'				Continue
'			End If

			Query = $"INSERT INTO ${DBAccess.TABLE_MODULES} VALUES (?,?,?,?,?,?,?,?,?,?,?)"$
			DBAccess.SQL.ExecNonQuery2(Query,Array(Module.ModuleName,Module.Folder,Module.FileName,Project.ProjectFileName,Module.Description,Module.ModuleType,Module.CodeLines,Module.CommentLines,Module.FileSize,Module.LastModified,Project.Folder))
				
			For Each S As String In Module.Subs
				
				Dim P As String = ""
				Dim Pos As Int = S.IndexOf("(")
				If Pos > -1 Then
					P = S.SubString(Pos)
					S = S.SubString2(0,Pos)
				Else
					Pos = S.IndexOf(" As")
					If Pos > -1 Then
						P = S.SubString(Pos)
						S = S.SubString2(0,Pos)
					End If
				End If
				Query = $"INSERT INTO ${DBAccess.TABLE_SUBS} VALUES (?,?,?,?,?)"$
				DBAccess.SQL.ExecNonQuery2(Query,Array(Module.FileName,Module.Folder,Project.ProjectFileName , S, P))
			Next
			
			For Each S As String In Module.Types
				Dim P As String = ""
				Dim Pos As Int = S.IndexOf("(")
				If Pos > -1 Then
					P = S.SubString(Pos)
					S = S.SubString2(0,Pos)
				Else
					Log("Invalid Type definition in " & S)
				End If
				Query = $"INSERT INTO ${DBAccess.TABLE_TYPES} VALUES (?,?,?,?,?)"$
				DBAccess.SQL.ExecNonQuery2(Query,Array(Module.FileName,Module.Folder,Project.ProjectFileName, S, P))
			Next
			
			For Each S As String In Module.JavaClasses
				Query = $"INSERT INTO ${DBAccess.TABLE_JAVACLASSES} VALUES (?,?,?,?)"$
				DBAccess.SQL.ExecNonQuery2(Query,Array(Module.FileName,Module.Folder,Project.ProjectFileName, S))
			Next
			For Each S As String In Module.JavaEvents
				Query = $"INSERT INTO ${DBAccess.TABLE_JAVAEVENTS} VALUES (?,?,?,?)"$
				DBAccess.SQL.ExecNonQuery2(Query,Array(Module.FileName,Module.Folder,Project.ProjectFileName, S))
			Next
			For Each S As String In Module.Forms
				Query = $"INSERT INTO ${DBAccess.TABLE_FORMS} VALUES (?,?,?,?)"$
				DBAccess.SQL.ExecNonQuery2(Query,Array(Module.FileName,Module.Folder,Project.ProjectFileName, S))
			Next
		Next
			
	Catch
		Log(Query)
		Log(LastException)
		DBAccess.SQL.Rollback
	End Try
	
	DBAccess.SQL.TransactionSuccessful
	
'	CallSubDelayed(ScanProjectStatic,"UpdateProject_Complete")
End Sub

Public Sub DeleteProject(Folder As String, FileName As String)
	DBAccess.SQL.BeginTransaction
	Try
		For Each Table As String In DBAccess.AllDataTables
			RemoveTableData(Table,FileName,Folder)
		Next
	Catch
		Log(LastException)
		DBAccess.SQL.Rollback
	End Try
	DBAccess.SQL.TransactionSuccessful
End Sub


Private Sub RemoveTableData(Table As String, FileName As String, Folder As String)
	Dim Query As String
	Query = $"DELETE From ${Table} WHERE ProjectFileName = ? And Folder = ?"$
	DBAccess.SQL.ExecNonQuery2(Query,Array As String(FileName,Folder))
End Sub

Public Sub DeleteAll
	DBAccess.SQL.BeginTransaction
	Try
		For Each Table As String In DBAccess.AllDataTables
			DeleteAllTableData(Table)
		Next
	Catch
		Log(LastException)
		DBAccess.SQL.Rollback
	End Try
	DBAccess.SQL.TransactionSuccessful
End Sub

Private Sub DeleteAllTableData(Table As String)
	Dim Query As String
	Query = $"DELETE From ${Table}"$
	DBAccess.SQL.ExecNonQuery(Query)
End Sub

Private Sub BoolAsInt(BVal As Boolean) As Int
	If BVal Then Return 1
	Return 0
End Sub

