﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=6.51
@EndOfDesignText@
'Static code module
Sub Process_Globals
	#If Git
	Private fx As JFX
	Type GitStructType(ProjectType As String,ProjectFIle As String, UnStaged As List, UnCommitted As List, Diffs As List, Branch As String, Folder As String, FileName As String)
	Type TTISortType(Sort As String, Data As String)
	
	Private TreeTableView1 As TreeTableView
	Public GitList As List
	Private GForm As Form
	Private lblShowingCount As Label
	Private PathMap As Map
	Private SFP As SelectFilePath
	Private btnRunGit As Button
	Private btnRefresh As Button
	#end if
	
End Sub
#If Git

Sub btnRefresh_Click
	Show
End Sub

Sub btnRunGit_Click
	If TreeTableView1.SelectedItem.IsInitialized = False Then 
		fx.Msgbox(GForm,"Please select a project","Project not selected")
		Return
	End If
	If UserOptions_Static.GetPathToGitGui = "" Then
		If SFP.IsInitialized = False Then
			SFP.Initialize(Me,"SFP","Path to Git App","")
		End If
		SFP.Show
		Sleep(0)
	End If
	
	ShowGit(UserOptions_Static.GetPathToGitGui,PathMap.Get(TreeTableView1.SelectedItem))
End Sub

Private Sub SFP_Done(NewPath As String)
	UserOptions_Static.SetPathToGitGui(NewPath)
End Sub

'Start the specified app with the working folder set to the project folder.
Private Sub ShowGit(PathToGit As String,ProjectFolder As String) As Boolean
	If PathToGit = "" Then Return False
	Dim Sh As Shell
	Sh.Initialize("Sh1",PathToGit,Null)
	Sh.WorkingDirectory = ProjectFolder
	Sh.Run(-1)
	Return True
End Sub

Private Sub SH1_ProcessCompleted (Success As Boolean, ExitCode As Int, StdOut As String, StdErr As String)
	'GitGui: For some reason the command initially fails with errorcode -559038737, but then opens the GitGui anyway
	If Success = False And ExitCode <> -559038737 Then
		fx.Msgbox(Null,$"Failed to start requested app, please check the path passed${CRLF}${StdErr}"$,"Could note start requested app")
	End If
End Sub

Private Sub TreeTableView1_Resize (Width As Double, Height As Double)
	Dim W As Double = Width - 20
	TreeTableView1.SetColumnWidth(0,W / 5)
	TreeTableView1.SetColumnWidth(1,W / 5)
	TreeTableView1.SetColumnWidth(2,W / 5)
	TreeTableView1.SetColumnWidth(3,W / 5)
	TreeTableView1.SetColumnWidth(4,W / 5)
End Sub

Public Sub Show
	GitList.Initialize
	PathMap.Initialize

	If GForm.IsInitialized = False Then
		GForm.Initialize("GForm",900,700)
		GForm.RootPane.LoadLayout("GitView")
		GForm.Title = "Git Status"
		GForm.Stylesheets.Add(File.GetUri(File.DirAssets,"main.css"))
		TreeTableView1.SetColumns(Array As String("Project","Branch","UnStaged","UnCommitted","Diff"))
	End If
	btnRunGit.Enabled = False
	btnRefresh.Enabled = False
	GForm.Show
	
	TreeTableView1.Root.Children.Clear
	PathMap.Clear
	
	Dim L As List = DBQueries.GetProjects(True)
	For Each Project() As String In L
		lblShowingCount.Text = $"Parsing Project ${Project(Main.PROJECT_PROJECTFILENAME)} : ${GitList.Size} of ${L.Size}"$
		Sleep(0)
		Dim GST As GitStructType = NewGitStruct(Project(Main.PROJECT_FOLDER),ScanProjectStatic.GitRepo)
		GST.ProjectFIle = Project(Main.PROJECT_PROJECTFILENAME)
		GST.ProjectType = GST.ProjectFIle.SubString(GST.ProjectFIle.LastIndexOf("."))
		ParseGit(GST)
		
		Dim LblFile As Label
		LblFile.Initialize("")
		LblFile.Text = GST.ProjectFIle
		LblFile.Font = fx.DefaultFont(13)
		LblFile.TooltipText = Project(Main.PROJECT_FOLDER)
		
		Dim LblUnstaged As Label
		LblUnstaged.Initialize("")
		LblUnstaged.Text = GST.UnStaged.Size
		LblUnstaged.Font = fx.DefaultFont(13)
		LblUnstaged.Alignment = "CENTER_RIGHT"
		BindWidth(LblUnstaged,2)
		
		Dim LblUnCommitted As Label
		LblUnCommitted.Initialize("")
		LblUnCommitted.Text = GST.UnCommitted.Size
		LblUnCommitted.Font = fx.DefaultFont(13)
		LblUnCommitted.Alignment = "CENTER_RIGHT"
		BindWidth(LblUnCommitted,3)
		
		Dim LblDiffs As Label
		LblDiffs.Initialize("")
		LblDiffs.Text = GST.Diffs.Size
		LblDiffs.Font = fx.DefaultFont(13)
		LblDiffs.Alignment = "CENTER_RIGHT"
		BindWidth(LblDiffs,4)
		
		Dim PT As String = Project(Main.PROJECT_PROJECTFILENAME).SubString(Project(Main.PROJECT_PROJECTFILENAME).LastIndexOf(".")+1)
		CSSUtils.SetBackgroundColor(LblFile,fx.Colors.From32Bit(UserOptions_Static.GetUserOption("color" & PT)))

		Dim TTI As TreeTableItem
		TTI.Initialize("TTI",Array(LblFile,GST.Branch,LblUnstaged,LblUnCommitted,LblDiffs))
		TreeTableView1.Root.Children.Add(TTI)
		
		PathMap.Put(TTI,Project(Main.PROJECT_FOLDER))
		
		Dim UnStaged, UnCommitted, Diff As String
		Dim TTIST As TTISortType
		For i = 0 To Max(Max(GST.UnStaged.Size,GST.UnCommitted.Size),GST.Diffs.Size) - 1
			
			If GST.UnStaged.Size > i Then
				TTIST = GST.UnStaged.Get(i)
				UnStaged = TTIST.Data
			Else
				UnStaged = ""
			End If
			
			If GST.UnCommitted.Size > i Then
				TTIST = GST.UnCommitted.Get(i)
				UnCommitted = TTIST.Data
			Else
				UnCommitted = ""
			End If
			
			If GST.Diffs.Size > i Then
				TTIST = GST.Diffs.Get(i)
				Diff = TTIST.Data
			Else
				Diff = ""
			End If
			
			Dim TTID As TreeTableItem
			TTID.Initialize("TTIDetail",Array As String("","",UnStaged,UnCommitted,Diff))
			TTI.Children.Add(TTID)
		Next
	Next
	lblShowingCount.Text = $"Showing projects : ${TreeTableView1.Root.Children.Size} of ${L.Size}"$
	btnRunGit.Enabled = True
	btnRefresh.Enabled = True
End Sub

Private Sub BindWidth(lbl As JavaObject,ColNo As Int)
	Dim WP As JavaObject = lbl.RunMethod("prefWidthProperty",Null)
	Dim JO As JavaObject = TreeTableView1
	Dim Cols As List = JO.RunMethod("getColumns",Null)
	Dim Col As JavaObject = Cols.Get(ColNo)
	Dim ColWP As JavaObject = Col.RunMethod("widthProperty",Null)
	WP.RunMethod("bind",Array(ColWP))
End Sub

Private Sub ParseGit(GST As GitStructType)	
	Dim Rep As Repository = FileRepositoryBuilder.Create(GST.Folder,GST.FileName)
	Dim G As Git
	G.Initialize
	G.Create(Rep)
	
	
	GST.Branch = Rep.GetBranch
	
	Dim Stat As Status = G.GetStatus.Call
	
	Dim L As List = Stat.GetModified
	L.AddAll(Stat.GetUntracked)
	For Each S As String In L
		Dim TTISD As TTISortType
		TTISD.Initialize
		TTISD.Data = S
		If S.Contains("/") Or S.Contains("\") Then
			TTISD.Sort = Regex.Split("[/|\\]",S)(1)
		Else
			TTISD.Sort = S
		End If
		GST.UnStaged.Add(TTISD)
	Next

	GST.UnStaged.SortTypeCaseInsensitive("Sort",True)
	
	
	L.Clear
	L.AddAll(Stat.GetChanged)
	L.AddAll(Stat.GetAdded)
	L.AddAll(Stat.GetRemoved)
	
	For Each S As String In L
		Dim TTISD As TTISortType
		TTISD.Initialize
		TTISD.Data = S
		If S.Contains("/") Or S.Contains("\") Then
			TTISD.Sort = Regex.Split("[/|\\]",S)(1)
		Else
			TTISD.Sort = S
		End If
		GST.UnCommitted.Add(TTISD)
	Next
	
	GST.UnCommitted.SortTypeCaseInsensitive("Sort",True)
	
	L.Clear
	L.AddAll(G.Diff.Call)
	
	For Each DE As DiffEntry In L
		Dim TTISD As TTISortType
		TTISD.Initialize
		S = DE.ToString
		S = Utils.GetEnclosed("[","]",S)
		TTISD.Data = S
		If S.Contains("/") Or S.Contains("\") Then
			TTISD.Sort = Regex.Split("[/|\\]",S)(1)
		Else
			TTISD.Sort = S.SubString(S.IndexOf(" ")).Trim
		End If
		GST.Diffs.Add(TTISD)
	Next
	
	GST.Diffs.SortTypeCaseInsensitive("Sort",True)
	
	Rep.Close
	
	GitList.Add(GST)
End Sub


Private Sub NewGitStruct(Folder As String, FileName As String) As GitStructType
	Dim GST As GitStructType
	GST.Initialize
	GST.UnStaged.Initialize
	GST.UnCommitted.Initialize
	GST.Diffs.Initialize
	GST.Folder = Folder
	GST.FileName = FileName
	Return GST
End Sub
#End If

